#include "c_beleg7.h"
#include "datenfile.h"
#include "indexfile.h"
#include "liste.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

char pruefeExistenzIndexfile(char *indexfile, char overwrite){
	FILE *fp;
	char abfrage;
	
	//prfen ob Indexfile existiert
	fp=fopen(indexfile,"rb");				
	if(!fp){						//Datei existiert nicht
		printf("Indexfile existiert nicht. Neu anlegen (j/n)?: ");
		abfrage=getchar(); Fflush();
		if(abfrage=='J' || abfrage=='j'){
			fp=fopen(indexfile,"ab");		//File anlegen (Append-Modus)
			if(!fp)
				return 2;
			else fclose(fp);
		}else return 1;					//Rckgabe
	}else{
		if(!overwrite){
			printf("Datei existiert bereits - ueberschreiben (j/n)?: ");
			abfrage=getchar(); Fflush();
			if(abfrage=='n' || abfrage=='N')
				return 1;
		}
		fclose(fp);
		fp=fopen(indexfile,"wb");
		if(!fp)
			return 2;
		else fclose(fp);
	}
	
	return 0;
}

char erstelleIndexfile(char *datenfile, char **indexfile){
	FILE *fp;						//Filepointer
	iindex *ind;						//Index fr Indexfile
	datensatz neu;						//Datensatz aus Datenfile
	element *akt, *kopf=NULL;				//verkettete Liste
	char overwrite=0, retval;
	
	if(*indexfile==NULL){
		*indexfile=(char*)malloc(100);
		printf("Indexfile angeben: ");
		scanf("%s",*indexfile); Fflush();
	}else overwrite=1;
	
	if((retval=pruefeExistenzIndexfile(*indexfile, overwrite))!=0){
		free(*indexfile); *indexfile=NULL;
		return retval;
	}
	
	//Daten aus Datenfile in verkettete Liste einlesen
	fp=fopen(datenfile, "rb");				//ffnen des Datenfiles
	if(!fp){
		fclose(fp);
		return 2;
	}
	while(fread(&neu,sizeof(neu),1,fp)){			//Lesen des Datenfiles
		ind=(iindex*)malloc(sizeof(iindex));		//Platz fr ein Indexelement reservieren
		akt=(element*)malloc(sizeof(element));		//neues Listenelement erzeugen
		akt->ind=ind;					//neues Indexelement mit Liste verketten
		strncpy(ind->name,neu.name,30);			//Name auf Zk kopieren
		ind->position=ftell(fp)-sizeof(neu);		//Position des Datenzeigers minus ein Element
		kopf=sorteinfuegen(akt,kopf);			//sortiertes Einfgen des gelesenen Elements in die Liste
	}
	if(ferror(fp)){						//Lesefehler aufgetreten
		fclose(fp);
		loescheListe(kopf);
		return 2;
	}
	fclose(fp);
	printf("\nIndexfile erstellt:\n");
	sequAusgabeListe(kopf);
	
	//Daten aus verketteter Liste in Indexfile schreiben
	fp=fopen(*indexfile,"wb");
	akt=kopf;
	while(akt){						//lesen bis Ende der verk. Liste erreicht
		fwrite(akt->ind,sizeof(iindex),1,fp);		//Schreibe in Indexfile
		akt=akt->next;					//Element der verk. Liste weitersetzen
	}
	loescheListe(kopf);
	if(ferror(fp)){						//Schreibfehler aufgetreten
		fclose(fp);
		return 2;
	}
	fclose(fp);
	
	return 0;
}

char sortAusgabeDatenfile(char *datenfile, char *indexfile){
	iindex ind;						//Index fr Indexfile
	datensatz neu;						//Datensatz aus Datenfile
	FILE *fp, *fp1;						//Filepointer
	
	if(indexfile==NULL){
		printf("Noch kein Indexfile erstellt!\n");
		return 1;
	}
	
	//nun werden die Datenstze aus dem Datenfile mit Hilfe des Indexfiles ausgegeben
	printf("Ausgabe sortiert nach Name:\n"
	       "---------------------------\n");
	fp=fopen(datenfile,"rb");
	if(!fp)
		return 2;
	fp1=fopen(indexfile,"rb");
	if(!fp1){
		fclose(fp);
		return 2;
	}
	while(fread(&ind,sizeof(ind),1,fp1)){
		fseek(fp,ind.position,SEEK_SET);
		fread(&neu,sizeof(neu),1,fp);
		if(ferror(fp)){					//Schreibfehler aufgetreten
			fclose(fp); fclose(fp1);
			return 2;
		}
		printf("\nDatensatz Nr. %d:\n",(int)(ind.position/sizeof(datensatz))+1);
		printf("Name:     %s\n",neu.name);
		printf("Vorname:  %s\n",neu.vorname);
		printf("Adresse:  %s\n",neu.adresse);
	}
	if(ferror(fp1)){					//Schreibfehler aufgetreten
		fclose(fp); fclose(fp1);
		return 2;
	}
	fclose(fp);
	fclose(fp1);
	
	return 0;
}

char sucheNachNamen(char *datenfile, char *indexfile){
	int r, l, m, s=sizeof(iindex);		//Grenzen fr binre Suche
	int laenge;				//Lnge eines Strings
	char name[30];
	iindex ind;
	datensatz neu;
	FILE *fp, *fp1;
	
	if(indexfile==NULL){
		printf("Noch kein Indexfile erstellt!\n");
		return 1;
	}
	
	printf("Nach welchem (Teil-) Namen soll gesucht werden?: ");
	scanf("%s",name); Fflush();
	laenge=strlen(name);
	
	//binre Suche im Indexfile nach name
	//es wird nur der erste Fund von name ausgegeben, nicht alle Datenstze,
	//welche mit dem Namen beginnen, wenn er mehrdeutig ist
	//=> dies knnte noch angepasst werden, war aber nicht Teil der Aufgabenstellung
	l=0;					//linke Grenze festlegen
	fp=fopen(indexfile,"rb");		//Indexfile ffnen
	if(fseek(fp,0,SEEK_END)==-1){		//Dateiende lesen
		fclose(fp);
		return 2;
	}
	r=ftell(fp)/s-1;			//rechte Grenze lesen
	while(r>=l){
		m=(r+l)/2;
		if(fseek(fp,m*s,SEEK_SET)==-1){	//in Mitte positionieren
			fclose(fp); 
			return 2;
		}
		if(!fread(&ind,sizeof(ind),1,fp)/* && r!=anz_ds*/){	//Indexsatz lesen
			fclose(fp); 
			return 2;
		}
		if(strncmp(name,ind.name,laenge)==0){
			fp1=fopen(datenfile,"rb");
			if(!fp1){
				fclose(fp);
				return 2;
			}
			fseek(fp1,ind.position,SEEK_SET);
			fread(&neu,sizeof(neu),1,fp1);
			if(ferror(fp1)){
				fclose(fp); fclose(fp1);
				return 2;
			}
			printf("%s zuerst gefunden in: ",name);
			printf("\nDatensatz Nr. %d:\n",(int)(ind.position/sizeof(datensatz))+1);
			printf("Name:     %s\n",neu.name);
			printf("Vorname:  %s\n",neu.vorname);
			printf("Adresse:  %s\n",neu.adresse);
			fclose(fp); fclose(fp1);
			return 0;
		}
		if(strncmp(name,ind.name,laenge)<0)
			r=m-1;
		else	l=m+1;
	}
	printf("Name nicht gefunden!\n");
	fclose(fp);
	return 0;
}
